
%clear all

% Functions of two variables
tic
% f(x,y)=x^2+y^2;

% domain of the function

Nx=100;
Ny=100;
x = linspace(-3,3,Nx);
y = linspace(-3,3,Ny);

[X,Y] = meshgrid(x,y);

% now the function

Z = 4-X;
 
figure;
surf(X,Y,Z);
xlabel('x');
ylabel('y');
title('z = (x^2 + 3y');
hold on

%Z2 = X.^2 - Y.^2;

% figure;
% surf(X,Y,Z2);
% xlabel('x');
% ylabel('y');
% title('z = x^2 - y^2');

% next  for the homework

data = [];
Nz=10;
Ns=50;
%figure;
for i=1:1:Nx
    for j=1:1:Ny
        if abs(x(i)^2+y(j)^2 -1)<=0.05
            plot3(x(i),y(j),Z(j,i),'r*');
            data = [data;x(i),y(j),Z(i,j)];
            hold on
            grid on
            box on
            ax = gca;
            ax.BoxStyle = 'full';
            xlabel('x');
            ylabel('y');
            title('f(x,y)= 4-x s.t. g(x,y) = x^{2} + y^{2}=1','interpreter','tex');
            %axis([-1.5 1.5 -2.5 2.5 0 4.5]);

            %
        end
    end
end
hold on
f = @(x,y) x.^2 + y.^2 - 1;
fimplicit(f,[-2 2 -2 2])
% hold on 
% datasize = size(data);
% index=floor(linspace(1,datasize(1),Ns));
% for s=1:1:length(index)
%     for i=1:1:Nz
%     plot3(data(index(s),1),data(index(s),2),data(index(s),3)*(i/Nz),'black.');
%     hold on
%     end
% end
hold on 
plot3([1 1],[0 0],[0 3],'black');
hold on 
plot3([-1 -1],[0 0],[0 5],'black');
hold on 
plot3(1,0,0,'*black');
hold on 
plot3(-1,0,0,'*black');
hold on 
plot3(1,0,3,'black o','MarkerFaceColor','black');
hold on 
plot3(-1,0,5,'black o','MarkerFaceColor','black');
toc